/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 *  WebSphere sMash
 *
 * (C) Copyright IBM Corp. 2007  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
 
package user;

def onList(){

	if(!checkIfFileUserService()) return;
	
	def result = zero.core.webtools.user.UserServiceWrapper.listUsers()
    request.view='JSON'
    request.json.output = result
    render()
}


def onRetrieve(){
	if(!checkIfFileUserService()) return;
	
	
	def userName = request.params.userId[]
	// check to see if user exists.  if does not exist, return a 404; else proceed.
	def result = zero.core.webtools.user.UserServiceWrapper.isUser(userName);
	if(result == false ){
		request.status = java.net.HttpURLConnection.HTTP_NOT_FOUND
		def message = (new zero.core.utils.ClientMessageFormatter("zero.core.webtools.user.resource.messages")).getMessage("unable.to.retrieve.user", (String[]) [userName])
		print(message)

	}
	else{
		result = zero.core.webtools.user.UserServiceWrapper.getUser(userName);
	    request.view='JSON'
	    request.json.output = result
	    render()
	}
}


def onUpdate(){
	
	if(!checkIfFileUserService()) return;
	
	
	def user = zero.json.Json.decode(request.input[])
	def userName = request.params.userId[]
	def password = user["password"];
	def groups = user["groups"];

	// check to see if user exists.  if does not exist, return a 404; else proceed.
	def result = zero.core.webtools.user.UserServiceWrapper.isUser(userName);
	if(result == false ){
		request.status = java.net.HttpURLConnection.HTTP_NOT_FOUND
		def message = (new zero.core.utils.ClientMessageFormatter("zero.core.webtools.user.resource.messages")).getMessage("unable.to.update.user", (String[]) [userName])
		print(message)
	}
	else{
		result = zero.core.webtools.user.UserServiceWrapper.updateUser(userName, (String)password, groups);
		if(result == true){	// updated user successfully
	    	request.status = java.net.HttpURLConnection.HTTP_NO_CONTENT
		}
		else{
			request.status = java.net.HttpURLConnection.HTTP_INTERNAL_ERROR
			def message = (new zero.core.utils.ClientMessageFormatter("zero.core.webtools.user.resource.messages")).getMessage("failed.to.update.user", (String[]) [userName])
			print(message)
		}
	}
}

def onDelete(){

	if(!checkIfFileUserService()) return;
	
	
	def userName = request.params.userId[]

	// check to see if user exists.  if does not exist, return a 404; else proceed.
	def result = zero.core.webtools.user.UserServiceWrapper.isUser(userName);
	if(result == false ){
		request.status = java.net.HttpURLConnection.HTTP_NOT_FOUND

		def message = (new zero.core.utils.ClientMessageFormatter("zero.core.webtools.user.resource.messages")).getMessage("unable.to.delete.user", (String[]) [userName])
		print(message)

	}
	else{
		result = zero.core.webtools.user.UserServiceWrapper.deleteUser(userName);
		if(result == true){ // deleted user successfully
	    	request.status = java.net.HttpURLConnection.HTTP_NO_CONTENT
		}
		else{
			request.status = java.net.HttpURLConnection.HTTP_INTERNAL_ERROR
			def message = (new zero.core.utils.ClientMessageFormatter("zero.core.webtools.user.resource.messages")).getMessage("failed.to.delete.user", (String[]) [userName])
			print(message)
		}
	}
}

def onCreate(){
	
	if(!checkIfFileUserService()) return;
	
	def user = zero.json.Json.decode(request.input[])
	
	def userName = user["userName"]
	def password = user["password"]
	def groups = user["groups"]
	
	def result = zero.core.webtools.user.UserServiceWrapper.addUser(userName, password, groups)
	
	if(result == true){ // created user successfully
    	request.headers.out.Location =  zero.core.utils.URIUtils.getRequestedUri(false) + "/" + userName;
    	request.status = java.net.HttpURLConnection.HTTP_NO_CONTENT
	}
	else{
		request.status = java.net.HttpURLConnection.HTTP_INTERNAL_ERROR
		def message = (new zero.core.utils.ClientMessageFormatter("zero.core.webtools.user.resource.messages")).getMessage("failed.to.create.user", (String[]) [userName])
		print(message)
	}
}

def checkIfFileUserService(){
	def fileRegistryType = config.security.userservice.registryType[]
	if (!'file'.equals(fileRegistryType)){
		request.status = java.net.HttpURLConnection.HTTP_INTERNAL_ERROR
		def message = (new zero.core.utils.ClientMessageFormatter("zero.core.webtools.user.resource.messages")).getMessage("file.base.registry.not.enabled", (String[]) [fileRegistryType])
		print(message)
		return false;
	}
	return true;
}


